//#########################################################################
// 
//         Pong   v 0.50
//   
//    Main Program,just a little 2 link players 'test'
//   
//      Created 01/12/2001; 13:40:44
//
//           By David Coz  
//
//       Coz.hubert@infonie.fr
//
//##########################################################################



#define USE_TI89              // Produce .89z File

#define OPTIMIZE_ROM_CALLS // Use ROM Call Optimization

#define SAVE_SCREEN           // Save/Restore LCD Contents

#include <tigcclib.h>         // Include All Header Files
#include "sprites_pong.h"
#include "trig_tables.h"
#include "network.h" 
#include "key.h" 


// Useful (and fast) Macros,thanks to Thomas Nussbaumer
#define PIXOFFSET(x,y)  ((y<<5)-(y<<1)+(x>>3))
#define PIXADDR(p,x,y)  (((unsigned char*)(p))+PIXOFFSET(x,y))
#define PIXMASK(x)      ((unsigned char)(0x80 >> ((x)&7)))
#define GETPIX(p,x,y)   (!(!(*PIXADDR(p,x,y) & PIXMASK(x))))
#define SETPIX(p,x,y)   (*PIXADDR(p,x,y) |=  PIXMASK(x))
#define ABS(a)  (((a)<0) ? -(a): (a))
#define SGN(a)  (((a)<0) ? -1 : 1)
#define ASM_EXCHANGE(val1,val2) asm volatile ("exg %0,%1" : "=d" (val1),"=d" (val2) : "0" (val1),"1" (val2) : "memory","cc")


#define RACKET_WIDTH 15


#define WIN      7   
#define LOOSE    13   

enum choi {COMPUTER,SAME_CALC,TWO_PLAYER};

unsigned short my_machine = 0;
int ball_speed;
int computer_speed;

int side;



/*Find the Hardware Version for adjusting speed (found in TIGCC help)*/

unsigned long GetHardwareVersion ()
{
  unsigned long hwpb, *rombase;
  rombase = (unsigned long *)((*(unsigned long *)0xC8) & 0x600000);
  hwpb = rombase[65];
  return (hwpb - (unsigned long)rombase  < 0x10000 &&
    *(unsigned short *)hwpb > 22 ? *(unsigned long *)(hwpb + 22) : 1);
}


void delay(int d)
{
  int i;
  for(i = 0; i < d; i++)
  {
    while(!OSTimerExpired(6));
    OSTimerRestart(6);
  }
}

   


typedef struct 
{
	int x;
	int y;
	int dx;
	int dy;
	unsigned char angle;
} BALL;
BALL ball;

int yc;

unsigned char x1,x2,y1,y2;
void *light , *dark,*back_light,*back_dark;
unsigned long int frame;
int mode;

volatile long int mseconds = 0;
volatile long int mseconds50 = 0; 
volatile int seconds    = 0; 
volatile int minutes    = 0; 
volatile int reset  = 1; 
volatile int run  =1;



INT_HANDLER oldint5 = NULL;
DEFINE_INT_HANDLER (myint5handler) {
       if (reset) {
        seconds=minutes=reset=0;
    }
    else if (run){
 mseconds++;
//mseconds50=mseconds>>1;
 
 
 mseconds50++;
//mseconds50=mseconds50>>1;
        if (mseconds%5) {
         //mseconds = 0;
            seconds++;
            if (seconds == 60) {
                seconds = 0;
                minutes++;
              }

        }
    }
    ExecuteHandler(oldint5);
}

void draw_pong(unsigned char* plane,int x,int y)
{
PortSet(plane,239,127);
BitmapPut(x,y,(BITMAP *)&(unsigned char[]){0,25,0,88,
0x00,0x00,0x00,0x00,0x00,0x03,0xC0,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x03,0xE0,0x00,0x00,0x00,0x00,0x01,0xFF,0x00,0x00,0xFC,0x03,0xE0,0x1E,0x00,0x07,0xF8,0x0F,0xFF,0xC0,0x01,0xFF,0x01,0xE0,0x1F,0x00,0x1F,0xFC,0x3F,0x07,0xE0,0x03,0xFF,0x81,0xF0,0x0F,0x00,0x7C,0x3C,0x78,0x03,0xE0,0x07,0x9F,0x81,0xF0,0x0F,0x00,0xF0,0x18,0xF7,0x81,0xE0,0x7E,0x07,0xC1,0xF8,0x0F,0x01,0xE0,0x00,0xE7,0x81,0xE1,0xEE,0x07,0xC3,0xF8,0x0F,0x03,0xC0,0x00,0xC7,0x81,0xE3,0xDC,0x03,0xC3,0xFC,0x0F,0x07,0x80,0x00,0x07,0x81,0xC3,0x9C,0x03,0xC3,0xBC,0x0F,0x0F,0x00,0x00,0x0F,0x03,0xC7,0x9C,0x03,0xC3,0xBC,0x0E,0x0F,0x00,0x00,0x0F,0x07,0x8F,0x1C,0x03,0xC3,0x9E,0x0E,0x0E,0x00,0x0C,0xCF,0x0F,0x0F,0x00,0x03,0x87,0x1E,0x0E,0x1E,0x0F,0xF8,0xFF,0x3C,0x0F,0x00,0x07,0x87,0x0F,0x0E,0x1E,0x1F,0xF8,0x3F,0xF0,0x0F,0x00,0x07,0x87,0x0F,0x0E,0x1E,0x00,0x78,0x1E,0x00,0x0F,0x00,0x0F,0x07,0x07,0x9C,0x1E,0x00,0x70,0x1E,0x00,0x0F,0x80,0x0E,0x07,0x07,0x9C,0x1F,0x00,0xF0,0x1E,0x00,0x07,0x80,0x1C,0x0F,0x03,0xDC,0x1F,0x00,0xF0,0x1E,0x00,0x07,0xC0,0x38,0x0F,0x03,0xDC,0x0F,0x81,0xF0,0x1E,0x00,0x03,0xF0,0xF0,0x0F,0x01,0xF8,0x07,0xC7,0xE0,0x3C,0x00,0x01,0xFF,0xE0,0x0F,0x00,0xF8,0x03,0xFE,0xE0,0x3C,0x00,0x00,0x7F,0x00,0x0F,0x80,0x70,0x01,0xFD,0xE0,0x3C,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x01,0xC0,0x3C,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x03,0xC0,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x07,0x80
},&(SCR_RECT){{0,0,239,127}},A_REPLACE);
}


void GraySprite8(int x,int y,int h,char sprite[],unsigned char* plane1,
unsigned char* plane2,int mode)
{
	Sprite8(x,y,h,sprite,plane1,mode);
	Sprite8(x,y,h,sprite+h,plane2,mode);
}


// Return 1 if there is at least one collision 
// betwwen the sprite and pixels already drawn 
// Sprite shouldn't be larger than 8 pixels
int test_sprite(int x,int y,char sprite[],int height,unsigned char* plane)
{
int i;
unsigned char* addr=PIXADDR(plane,x,y);//Pixel Adress
unsigned long mask1 =PIXMASK(x),mask2,data;

mask1=2*mask1-1;
mask2=(~(mask1&255))|0xFF00;
mask1=((mask1<<8)|0x00FF)&mask2;
//Mask1 contains your sprite line

for(i=0;i<height;i++,addr+=30)
{
data=((unsigned long)(*(addr))<<8)+(*(addr+1));
//Data contains the Screen line

data=data&mask1&(((sprite[i]<<8))>>(x&7));
if (data!=0)
return 1;
}
return 0;
}

int check_other()
{
  char buffer[2];
	buffer[0] = 0;
  OSReadLinkBlock(buffer,1);
if (buffer[0]==1)
	return 0;
y2=buffer[0];
return 1;	
}


void set_ball_mov()
{
if (mode != TWO_PLAYER)
{
ball.angle-=10;
if (random(1))
ball.angle+=20;
}
ball_speed++;
	ball.dx=(cos255[ball.angle]*ball_speed)>>9;
	ball.dy=-(sin255[ball.angle]*ball_speed)>>9;

}




void load_background()
{
draw_pong(back_light,36,37);
	int i;
	for (i=0;i<27;i++)
	{
		GraySprite8(i*6,0,7,brick,back_light,back_dark,SPRT_XOR);
		GraySprite8(i*6,93,7,brick,back_light,back_dark,SPRT_XOR);
	}
	
	/*for (i=0;i<5;i++)
	{
		DrawLine(0,i,159,i,A_NORMAL);
		DrawLine(0,99-i,159,99-i,A_NORMAL);
	}
	PortSet(light,239,127);
	for (i=0;i<3;i++)
	{
		DrawLine(0,i,159,i,A_NORMAL);
		DrawLine(0,99-i,159,99-i,A_NORMAL);
	}*/
}

int key()
{
//ESC
if 	(_rowread(~((short)(1<<6))) & (1<<0))
return 0;

// Down is pressed
if (_rowread(0x7E)&0x04&&y1+RACKET_WIDTH<93)	
y1++;
	
	// Up is pressed
if (_rowread(0x7E)&0x01&&y1>6)
y1--;

if (mode==SAME_CALC)
{

	if (key_diam()&&y2+RACKET_WIDTH<93)
	y2++;
  if (key_2nd()&&y2>6)
  y2--;
}
return 1;
}


void draw_racket()
{

int dy,ay,slow;
//if (mode!=SAME_CALC)

	Sprite8(x1,y1,15,racket[side],light,SPRT_OR);
	Sprite8(x1,y1,15,racket[side]+15,dark,SPRT_OR);

/*else
{
Sprite8(x2,y2,15,racket[side],light,SPRT_OR);
	Sprite8(x2,y2,15,racket[side]+15,dark,SPRT_OR);
} 
*/
  if (mode == COMPUTER)
  {
  	
  	if (ball.dx>0)
   {
   	
    dy=SGN(yc-ball.y);
    ay=ABS(yc-ball.y)<<4;
   slow=(160-(ball.x>>4))>>4;

    yc-=(computer_speed)*dy;
    
        
    if ((yc>>4)+RACKET_WIDTH>94)
    yc=(94-RACKET_WIDTH)<<4;
  }
  Sprite8(x2,yc>>4,15,racket[1-side],light,SPRT_OR);
  Sprite8(x2,yc>>4,15,racket[1-side]+15,dark,SPRT_OR);
 
  }
	else
 {
  Sprite8(x2,y2,15,racket[1-side],light,SPRT_OR);
  Sprite8(x2,y2,15,racket[1-side]+15,dark,SPRT_OR);
 }
/* if (mode==SAME_CALC)
{
ASM_EXCHANGE(x1,x2);
ASM_EXCHANGE(y1,y2);
}
*/
}


int draw_ball()
{
	if (test_sprite((ball.x+ball.dx)>>4,
		 ball.y>>4,ball_spr+7,7,dark))
{
//ball.dx=-ball.dx;
ball.angle=127-ball.angle;
//ball.angle=-ball.angle;
set_ball_mov();
}
		 
	if (test_sprite(ball.x>>4,
		 (ball.y+ball.dy)>>4,ball_spr+7,7,dark))
{
//ball.dy=-ball.dy;
ball.angle=-ball.angle;

set_ball_mov();

}	
	ball.x+=ball.dx;
	ball.y+=ball.dy;
	
	
	if (ball.x<0)
	return LOOSE;
	
	if ((ball.x>>4)>157)
	return WIN;
	
  Sprite8(ball.x>>4,ball.y>>4,7,ball_spr,light,SPRT_OR);
  Sprite8(ball.x>>4,ball.y>>4,7,ball_spr+7,dark,SPRT_OR);
  return 0;
}

int display() 
{

int play=1;
if (mseconds50-frame<1)
return 1;
char buffer[2];

if (mode == TWO_PLAYER)
{
 buffer[0]=y1;
	 OSWriteLinkBlock(buffer,1);
	OSReadLinkBlock(buffer,1);
	y2=buffer[0];
//if (check_other()==0)   
	//return 0;
}

frame=mseconds50;
memcpy(light,back_light,3840);
memcpy(dark,back_dark,3840);

	/* 	if (getMachine() != NEITHER)
  	{	
  	buffer[0]=y1;
	 OSWriteLinkBlock(buffer,1);
	   }	
	  */ 

play=key();
/*	if (getMachine() != NEITHER)
{
		if (check_other()==0)   
	return 0;
}*/
draw_racket();
if (draw_ball()!=0)
return 0;


memcpy(GetPlane(0),light,3840);
memcpy(GetPlane(1),dark,3840);


return play;
	
}


void play()
{
char buffer[2];
	ClrScr();
		memset(GetPlane(0),0,3840);
	memset(GetPlane(1),0,3840);
	memset(light,0,3840);
	memset(dark,0,3840);
	memset(back_light,0,3840);
	memset(back_dark,0,3840);


	 if (mode == TWO_PLAYER)
  	{
  		DrawStr(50,50,"Connecting...",A_NORMAL);
		 while (getMachine() != NEITHER && networkReady() == FALSE &&!(_rowread(~((short)(1<<6))) & (1<<0)))
		   {
		   	delay(10);
		   }
			if (getMachine() == NEITHER ||(_rowread(~((short)(1<<6))) & (1<<0)) )
		     return ;

		if (getMachine() == SERVER)
		{
	   x1=1;
	   x2=155;
	   side=0;
		}
		if (getMachine() == CLIENT)
		{  
		   x1=155;
		   x2=1;
		   side=1;
		}

}
load_background();

		reset=1;
run=1;
frame=mseconds50;

	GrayOn();
while(display());	
	GrayOff();
	PortRestore();
}




// Main Function
void _main(void)
{

int set_level[3][2]={{14,50},{20,70},{26,90}};
run=0;
x1=1;
x2=155;
side=0;
char buffer[2];
OSFreeTimer(6);
  OSRegisterTimer(6,2);


randomize();
  pokeIO(0x600017,0xFA);
mode=COMPUTER;
ball.x=30<<4;
ball.y=30<<4;
ball.angle=235;

y1=30;
y2=30;
yc=30<<4;
light=malloc(3840);
dark=malloc(3840);
back_light=malloc(3840);
back_dark=malloc(3840);


oldint5 = GetIntVec(AUTO_INT_5);
SetIntVec(AUTO_INT_5, myint5handler);
INT_HANDLER save_int_1;
 save_int_1 = GetIntVec (AUTO_INT_1);
 SetIntVec (AUTO_INT_1, DUMMY_HANDLER);   


ClrScr();
networkPing();
  
int i=0,j,choice=0;
char *titles[3] = {"(Impossible...)", "(as Master...) ", "(as Slave...)  "};

draw_pong(LCD_MEM,37,2);
FontSetSys(F_8x10);

DrawStr(20,10,"*",A_NORMAL);
DrawStr(130,10,"*",A_NORMAL);

/*
DrawLine(30,30,130,30,A_NORMAL);
DrawLine(30,83,130,83,A_NORMAL);
DrawLine(30,83,30,30,A_NORMAL);
DrawLine(130,30,130,83,A_NORMAL);

DrawLine(29,31,129,31,A_NORMAL);
DrawLine(29,82,129,82,A_NORMAL);
DrawLine(29,82,29,31,A_NORMAL);
DrawLine(129,31,129,82,A_NORMAL);
*/

DrawClipRect (MakeWinRect (32, 32,128,81),&(SCR_RECT){{0, 0, 159, 99}}, 
/*B_DOUBLE|*/B_ROUNDED|A_NORMAL); 



FontSetSys(F_4x6);
DrawStr(38,88,"2002 v 0.5 by David Coz",A_NORMAL);
DrawStr(43,94,"Coz.hubert@infonie.fr",A_NORMAL);
FontSetSys(F_6x8);

while (key_esc()==0)
{
i++;
networkListen();
 delay(4);
  if (getMachine() != my_machine)
     my_machine = getMachine();
//FontSetSys(F_8x10);
//DrawStr(50,10,"* PONG *",A_NORMAL);

FontSetSys(F_6x8);
DrawStr(50,38,"- Normal",A_NORMAL);
DrawStr(50,51,"- 2_Players",A_NORMAL);

DrawStr(50,62,"- Link  :",A_NORMAL);
FontSetSys(F_4x6);
DrawStr(60,71,titles[getMachine()],A_REPLACE);
FontSetSys(F_6x8);

Sprite8(38,38+13*choice,7,ball_spr+7,LCD_MEM,SPRT_OR);
//DrawStr(30,38+13*choice,"->",A_REPLACE);

if (key_down()&&choice!=2&&!(choice==1&&getMachine()==0)&&i>5)
{
i=0;
Sprite8(38,38+13*choice,7,ball_spr+7,LCD_MEM,SPRT_XOR);
//DrawStr(30,38+13*choice,"  ",A_REPLACE);
choice++;
}
if (key_up()&&choice!=0&&i>5)
{
i=0;
Sprite8(38,38+13*choice,7,ball_spr+7,LCD_MEM,SPRT_XOR);

//DrawStr(30,38+13*choice,"  ",A_REPLACE);
choice--;
}
if (key_2nd()||key_ent())
break;
}
if (choice==1)
mode=SAME_CALC;

if (choice==2)
mode=TWO_PLAYER;

ball_speed=set_level[0][1];
computer_speed=set_level[0][0];
set_ball_mov();

if (mode==COMPUTER)
{
DrawStr(50,51,"           ",A_REPLACE);
DrawStr(50,62,"           ",A_REPLACE);
DrawStr(60,71,"           ",A_REPLACE);
delay(20);
i=0;
int level=0;

char *dif[3] = {"  Easy >  ", "< Medium >", "< Hard   "};
		
	while (key_esc()==0)
	{
	 i++;
	  DrawStr(47,55,"Difficulty :",A_REPLACE);
	 	DrawStr(55,65,dif[level],A_REPLACE);
	 	if (key_right()&&level<2&&i>20)
	 	{level++,i=0;}
	 	if (key_left()&&level!=0&&i>20)
	 	{level--,i=0;}
	 if (key_2nd()||key_ent()) 
   break;
	}
ball_speed=set_level[level][1];
computer_speed=set_level[level][0];
set_ball_mov();
}

if (!(_rowread(~((short)(1<<6))) & (1<<0)))
{
play();
}
if (GetHardwareVersion ()==2)
  pokeIO(0x600017,0xCC);
else
  pokeIO(0x600017,0xB1);

	free(light);
	free(dark);
		free(back_light);
	free(back_dark);
SetIntVec (AUTO_INT_1, save_int_1);
  SetIntVec(AUTO_INT_5, oldint5);	
	
}
